unit MainUnit;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, ControllerUnit, DEWESoft_TLB;

type
  TDCOMAppForm = class(TForm)
    ButtonStartDewesoft: TButton;
    ButtonStopDewesoft: TButton;
    ButtonAcquisition: TButton;
    ButtonChSetup: TButton;
    ButtonReadCh: TButton;
    EditChName: TEdit;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ButtonStartDewesoftClick(Sender: TObject);
    procedure ButtonStopDewesoftClick(Sender: TObject);
    procedure ButtonReadChClick(Sender: TObject);
    procedure ButtonAcquisitionClick(Sender: TObject);
    procedure ButtonChSetupClick(Sender: TObject);
  private
    FController: TController;
  public
  end;

var
  DCOMAppForm: TDCOMAppForm;

implementation

{$R *.dfm}

procedure TDCOMAppForm.ButtonAcquisitionClick(Sender: TObject);
begin
  if Assigned(FController) then
    DeweApp.Start;
end;

procedure TDCOMAppForm.ButtonChSetupClick(Sender: TObject);
begin
  if Assigned(FController) then
    DeweApp.SetupScreen;
end;

procedure TDCOMAppForm.ButtonReadChClick(Sender: TObject);
var
  Ch: IChannel;
  Val: Double;
  Str: string;
  SeekPos: Integer;
begin
  if not Assigned(FController) then
    Str := 'Dewesoft not started'
  else
  begin
    Ch := DeweApp.Data.FindChannel(EditChName.Text);
    if Assigned(Ch) then
    begin
      if DeweApp.IsAcqRunning then
      begin
        if not DeweApp.IsSetupMode and not Ch.Used then
          Str := 'Channel not used'
        else
        begin
          if Ch.DBDataSize > 0 then
          begin
            SeekPos := 0;
            Val := Ch.GetValueAtAbsPosDouble(-1, SeekPos, False);
            Val := Ch.ScaleValueDouble(Val);
            Str := 'Value = ' + FloatToStrF(Val, ffFixed, 8, 4);
          end else
            Str := 'Unable to read value';
        end;
      end else
        Str := 'Acquisition not running';
    end else
      Str := 'Could not find channel';
  end;
  MessageBox(Handle, PWideChar(Str), 'Read value', 0);
end;

procedure TDCOMAppForm.ButtonStartDewesoftClick(Sender: TObject);
begin
  if not Assigned(FController) then
  begin
    FController := TController.Create(nil);
    DeweApp.Visible := True;
  end;
end;

procedure TDCOMAppForm.ButtonStopDewesoftClick(Sender: TObject);
begin
  FreeAndNil(FController);
end;

procedure TDCOMAppForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FreeAndNil(FController);
end;

end.
