
%----------------------------------------------------------------------------------------------------------------
% Dewesoft automation example for Matlab
%----------------------------------------------------------------------------------------------------------------

close all
clc

global actx;
global start_calc;
global ReadCh;
global WriteCh;

SR = 100; % sample rate
start_calc = 0;

% create DCOM object
actx = actxserver('Dewesoft.App');

% open Dewesoft
fprintf('Initializing Dewesoft... ');
actx.Init();
actx.Enabled = true;
actx.Visible = true;
fprintf('done.\n');

% set window dimensions
actx.Top = 0;
actx.Left = 0;
actx.Width = 1024;
actx.Height = 768;

% build channel list
actx.Data.BuildChannelList();

% number of all channels
fprintf('\n');
display(['Number of all channels: ', num2str(actx.Data.AllChannels.Count)]);

% list of all channels
display('List of all channels:');
for i = 0 : actx.Data.AllChannels.Count - 1
    
    ChName = actx.Data.AllChannels.Item(i).Name;
	disp(ChName); 
  
    % we are going to read data from AI 1 channel
    if (strcmp(ChName, 'AI 1'))
        ReadCh = actx.Data.AllChannels.Item(i);
        ReadCh.Used = true;
    end    
end  
fprintf('\n');

% number of used channels
display(['Number of used channels: ', num2str(actx.Data.UsedChannels.Count)]);

% list of used channels
display('List of used channels:')
for i = 0 : actx.Data.UsedChannels.Count - 1
  disp(actx.Data.UsedChannels.Item(i).Name);
end  
fprintf('\n');
 
% set sample rate
actx.MeasureSampleRate = SR;

% register eventhandler
actx.registerevent('eventhandler');

% start measure mode and wait a little
delay = 30;
display(['Running measure mode for ', num2str(delay), ' seconds...']);
actx.Start();
pause(delay);

% stop measurement
actx.unregisterevent('eventhandler');
actx.Stop();
disp('Finished.');

actx.delete;
clear actx;
