
%----------------------------------------------------------------------------------------------------------------
% Dewesoft automation example for Matlab
%----------------------------------------------------------------------------------------------------------------
% Author: Dewesoft
%----------------------------------------------------------------------------------------------------------------

close all
clear all
clc

% create DCOM object
h = actxserver('Dewesoft.App');

% open Dewesoft
fprintf('Initializing Dewesoft... ');
h.Init();
h.Enabled = true;
h.Visible = true;
fprintf('done.\n');

% set window dimensions
h.Top = 0;
h.Left = 0;
h.Width = 1024;
h.Height = 768;

% build channel list
h.Data.BuildChannelList();

% number of all channels
fprintf('\n');
display(['Number of all channels: ', num2str(h.Data.AllChannels.Count)]);

% list of all channels
display('List of all channels:');
for i = 0 : h.Data.AllChannels.Count - 1
  display(h.Data.AllChannels.Item(i).Name);
end  
fprintf('\n');

% number of used channels
display(['Number of used channels: ', num2str(h.Data.UsedChannels.Count)]);

% list of used channels
display('List of used channels:')
for i = 0 : h.Data.UsedChannels.Count - 1
  display(h.Data.UsedChannels.Item(i).Name);
end  
fprintf('\n');

% set sample rate to 10 KHz
h.MeasureSampleRate = 10000;

% start measure mode and wait a little
delay = 5;
display(['Running measure mode for ', num2str(delay), ' seconds...']);
h.Start();
pause(delay)

% go to setup screen and wait a little
display(['Switching to setup screen for ', num2str(delay), ' seconds...']);
h.SetupScreen();
pause(delay)

% go again to measure screen and wait a little
display(['Running measure mode again for ', num2str(delay), ' seconds...']);
h.Start();
pause(delay)

% close dewesoft
fprintf('Closing Dewesoft... ');
h = [];
fprintf('done.\n');
