
#----------------------------------------------------------------------------------------------------------------
# Dewesoft automation example for Python
#----------------------------------------------------------------------------------------------------------------
# Author: Dewesoft
# Notes:
#   - tested with Python 3.4
#----------------------------------------------------------------------------------------------------------------

from win32com.client import Dispatch
import time
import sys

# create DCOM object
dw = Dispatch("Dewesoft.App")

# open Dewesoft
print("Initializing Dewesoft... ", end = "")
sys.stdout.flush()
dw.Init()
dw.Enabled = 1
dw.Visible = 1
print('done.')

# set window dimensions
dw.Top = 0
dw.Left = 0
dw.Width = 1024
dw.Height = 768

# build channel list
dw.Data.BuildChannelList()

# number of all channels
print("\nNumber of all channels: %d" % dw.Data.AllChannels.Count)

# list of all channels
print("List of all channels:")
for i in range(0, dw.Data.AllChannels.Count):
  print(dw.Data.AllChannels.Item(i).Name)
print("")

# number of used channels
print("Number of used channels: %d" % dw.Data.UsedChannels.Count)

# list of used channels
print("List of used channels:")
for i in range(0, dw.Data.UsedChannels.Count):
  print(dw.Data.UsedChannels.Item(i).Name)
print("")

# set sample rate to 10 KHz
dw.MeasureSampleRate = 10000

# start measure mode and wait a little
delay = 5
print("Running measure mode for %d seconds..." % delay)
dw.Start()
time.sleep(delay)

# go to setup screen and wait a little
print("Switching to setup screen for %d seconds..." % delay)
dw.SetupScreen()
time.sleep(delay)

# go again to measure screen and wait a little
print("Running measure mode again for %d seconds..." % delay)
dw.Start()
time.sleep(delay)

# close dewesoft
print("Closing Dewesoft... ", end = "")
sys.stdout.flush()
dw = None
print("done.")
sys.stdout.flush()
