
#----------------------------------------------------------------------------------------------------------------
# Dewesoft automation export example for Python
#----------------------------------------------------------------------------------------------------------------
# Author: Dewesoft
# Notes:
#   - tested with Python 3.4
#----------------------------------------------------------------------------------------------------------------

from win32com.client import Dispatch
import sys

# create DCOM object
dw = Dispatch("Dewesoft.App")

# open Dewesoft
print("Initializing Dewesoft... ", end = "")
sys.stdout.flush()
dw.Init()
print('done.')

# load a file
print("Loading file... ", end = "")
sys.stdout.flush()
dw.LoadFile("C:/DXEProjects/DewesoftX2/DEWEsoft/Data/test.d7d")
print('done.')

# export file to a TXT format (7 corresponds to the TXT export)
# ExportData usage:
# ExportData(ExportType, TimeAxis, FileName)
#   - ExportType: corresponds to the file format index: FlexPro = 0, Excel = 1 etc. (for more details see "Export file type" list in Dewesoft)
#   - TimeAxis: 0 .. relative time, 1 .. absolute time, 2 .. from trigger
#   - FileName: name of the exported file
print("Exporting file... ", end = "")
sys.stdout.flush()
dw.ExportData(7, 0, "C:/DXEProjects/DewesoftX2/DEWEsoft/Exports/test.txt")
print('done.')

# close dewesoft
print("Closing Dewesoft... ", end = "")
sys.stdout.flush()
dw = None
print("done.")
sys.stdout.flush()
